/*

  output.h

  Format du fichier objet compil

*/

#ifndef _OUTPUT_H
#define _OUTPUT_H


#if 0
typedef
  unsigned long OUTPUT_TYPE;


typedef
  struct {
    OUTPUT_TYPE type;                   /* type de la variable de classe */
    long index;                         /* index du nom de la variable de classe */
    long pos;                           /* position d'allocation en mmoire */
    }
  PACKED OUTPUT_VARIABLE;


typedef
  struct {
    OUTPUT_TYPE type;                   /* type du paramtre ou de la variable locale */
    long index;                         /* index du nom du paramtre ou de la variable locale */
    }
  PACKED OUTPUT_PARAM;


typedef
  struct {
    OUTPUT_TYPE type;                   /* type de la constante */
    long index;                         /* index du nom de la constante dans la table des symboles */
    long value;                         /* index de la valeur de la constante dans la table des symboles */
    }
  PACKED OUTPUT_CONSTANT;


typedef
  struct {
    OUTPUT_TYPE type;                   /* type de la valeur de retour de la fonction */
    long index;                         /* nom de la mthode */

    short nbr_param;                    /* nombre de paramtres */
    OUTPUT_PARAM *param;                /* description des paramtres */

    short nbr_local;                    /* nombre de variables locales */
    OUTPUT_PARAM *local;                /* description des variables locales */

    short nbr_code;                     /* nombre de mots de p-code */
    unsigned short *code;               /* pointeur sur le p-code de la mthode */

    short finally;                      /* position du finally */
    short catch;                        /* position du catch */
    }
  PACKED OUTPUT_METHOD;


typedef
  struct {
    long sort;                          /* index de tri des symboles */
    char *name;                         /* pointeur sur le nom du symbole dans la table des chanes */
    long len;                           /* longueur du symbole */
    }
  PACKED OUTPUT_SYMBOL;


typedef
  struct {
    unsigned long _magic;               /* Identifie un fichier objet */

    long parent_index;                  /* N/A index du nom de la classe parent dans la table des symboles */

    long size_static;                   /* taille  allouer pour les variables statiques */
    void *val_static;                   /* pointeur sur la zone mmoire alloue aux variables statiques */
    short nbr_static_var;               /* nombre de variables statiques */
    OUTPUT_VARIABLE *static_var;        /* description des variables statiques */

    long size_dynamic;                  /* taille  allouer pour les variables dynamiques */
    short nbr_dynamic;                  /* nombre de variables dynamiques */
    OUTPUT_VARIABLE *dynamic_var;       /* description des variables dynamiques */

    short nbr_method;                   /* nombre de mthodes */
    OUTPUT_METHOD *method;              /* description des mthodes */

    short nbr_constant;                 /* nombre de constantes */
    OUTPUT_CONSTANT *constant;          /* description des constantes */

    short nbr_class;                    /* nombre de rfrences  des classes */
    long *class;                        /* index des noms de classes dans la table des symboles */

    long nbr_symbol;                    /* nombre de symboles */
    OUTPUT_SYMBOL *symbol;              /* table des symboles */
    }
  PACKED OUTPUT_CLASS;
#endif

typedef
  struct {
    long sort;
    char *name;
    long len;
    long pos;
    }
  OUTPUT_SYMBOL;


enum
{
  CD_PROPERTY_ID          = 1,
  CD_METHOD_ID            = 2,
  CD_STATIC_PROPERTY_ID   = 3,
  CD_STATIC_METHOD_ID     = 4,
  CD_CONSTANT_ID          = 5,
  CD_EVENT_ID             = 6
};


PUBLIC void OUTPUT_do(void);
PUBLIC char *OUTPUT_get_file(char *file);

#endif


