/*

  limit.h

  limites de l'interprteur

*/

#ifndef _LIMIT_H
#define _LIMIT_H

/* Nombre maximum de paramtres d'une fonction */
#define MAX_PARAM           127

/* Nombre maximum d'imbrication dans une expression */
#define MAX_EXPR_LEVEL      255

/* Nombre maximum de patterns dans une expression */
#define MAX_EXPR_PATTERN    1023

/* Longueur maximale d'un symbole */
#define MAX_SYMBOL_LEN      255

/* Nombre maximum de symboles d'un objet pour un type donn: statique, dynamique, ou mthode */
#define MAX_CLASS_SYMBOL    1024

/* Nombre maximum de variables locales d'une fonction */
#define MAX_LOCAL_SYMBOL    127

/* Nombre maximum de structures de controles imbriques */
#define MAX_CTRL_LEVEL      16

/* Nombre maximum de dimensions d'un tableau */
#define MAX_ARRAY_DIM       8

/* Nombre maximum de comparaisons dans un CASE */
#define MAX_CASE_EXPR       32

/* Nombre maximal de points d'arrets */
#define MAX_BREAKPOINT      32

/* Taille maximale d'un chemin */
#define MAX_PATH            255

/* Nombre d'octets maximum d'une entre/sortie */
#define MAX_IO              4096

/* Nombre maximum de niveaux d'hritages */
#define MAX_INHERITANCE     15

#endif

